{% if carousel and active %}
    {% set slides = carousel.slides.visible() %}
{% else %}
    {% set slides = [] %}
{% endif %}

{% macro render_slides(slides_as_listitem=False) %}
    {% for slide in slides %}
        {% set link = slide.get_link_url() %}
        {% set cropped_slide = slide|thumbnail(size=(carousel.image_width, carousel.image_height), crop="smart", upscale=True) %}
        {% set caption = slide.get_translated_field("caption") or "" %}
        {% set caption_text = slide.get_translated_field("caption_text") or "" %}

        {% if slides_as_listitem %}<li class="canvas-carousel__single-slide">{% else %}<div class="canvas-carousel__single-slide">{% endif %}
            {% if link %}<a href="{{ link }}" target="{{ slide.get_link_target() }}">{% endif %}

            <img src="{{ cropped_slide }}" alt="{{ caption }}">

            {% if render_image_text %}
                <div class="canvas-carousel__slide__captions">
                    {% if caption %}<h3 class="canvas-carousel__slide__title">{{ caption }}</h3>{% endif %}
                    {% if caption_text %}<div class="canvas-carousel__slide__text">{{ caption_text }}</div>{% endif %}
                </div>
            {% endif %}

            {% if link %}</a>{% endif %}
        {% if slides_as_listitem %}</li>{% else %}</div>{% endif %}
    {% endfor %}
{% endmacro %}

{% if slides|length %}
    <section class="canvas-carousel">
        {% if title %}
            <h2>{{ title }}</h2>
        {% endif %}

        {% if type == "carousel" %}
            {# check for custom colors #}
            <style>
                {% if carousel.arrows_color %}
                    .owl-nav .owl-prev,
                    .owl-nav .owl-next {
                        color: {{ carousel.arrows_color }} !important;
                    }
                {% endif %}
                {% for slide in slides %}
                    {% if slide.inactive_dot_color %}
                        .owl-dot:nth-child({{ loop.index }}) {
                            border-color: {{ slide.inactive_dot_color }} !important;
                        }
                    {% endif %}
                    {% if slide.active_dot_color %}
                        .owl-dot:nth-child({{ loop.index }}).active {
                            border: 1px solid {{ slide.active_dot_color }} !important;
                            background-color: {{ slide.active_dot_color }} !important;
                        }
                    {% endif %}
                {% endfor %}
            </style>
            <div
                class="canvas-carousel__slides owl-carousel carousel-plugin one"
                data-autoplay="{% if carousel.interval > 0 %}true{% else %}false{% endif %}"
                data-interval="{{ carousel.interval * 1000 }}"
                data-arrows-visible="{{ carousel.is_arrows_visible }}"
                data-pause-on-hover="{{ carousel.pause_on_hover }}"
                data-use-dot-navigation="{{ carousel.use_dot_navigation }}">
                {{ render_slides() }}
            </div>
        {% elif type == "banner_box" %}
            <div class="canvas-carousel__banners">
                <div class="canvas-carousel__banners__desktop">
                    {{ render_slides() }}
                </div>
                <div class="canvas-carousel__banners__mobile">
                    <div class="glide">
                        <div class="glide__track" data-glide-el="track">
                            <ul class="glide__slides">
                                {{ render_slides(slides_as_listitem=True) }}
                            </ul>
                        </div>
                        <div class="glide__controls" data-glide-el="controls">
                            <button class="glide__controls__back" data-glide-dir="<" aria-label="{% trans %}Previous{% endtrans %}">
                                {{ lazy_img_image(shuup_static('canvas/img/icons/icon-arrow-left.svg'), "", "") }}
                            </button>
                            <button class="glide__controls__next" data-glide-dir=">" aria-label="{% trans %}Next{% endtrans %}">
                                {{ lazy_img_image(shuup_static('canvas/img/icons/icon-arrow-right.svg'), "", "") }}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}
    </section>
{% endif %}
